<?php
/**
 * Created by PhpStorm.
 * User: Noa
 * Date: 19/09/2017
 * Time: 20:45
 */

namespace Noa\Example\Middlewares;


use GuzzleHttp\Psr7\Response;
use Interop\Http\ServerMiddleware\DelegateInterface;
use Interop\Http\ServerMiddleware\MiddlewareInterface;
use Noa\Example\Middlewares\Controller\BlogController;
use Noa\Router\Router;
use Noa\Router\RouterException;
use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;

class App implements MiddlewareInterface
{

    /**
     * Dispatch the next available middleware and return the response.
     *
     * @param ServerRequestInterface $request
     *
     * @return ResponseInterface
     */
    public function process(ServerRequestInterface $request, DelegateInterface $delegate)
    {
        // TODO: Implement process() method.

        $router = Router::getInstance();
        Router::setRequest($request);

        $router->get('/blog', BlogController::class."#home");
        $router->post('/blog/page', BlogController::class."#create");
        $router->get('/blog/page/:id', BlogController::class."#page");
        $router->get('/blog/error', BlogController::class."#error");

        try {

            $router->run();
            $response = Router::getResponse();

        } catch (RouterException $e) {

            switch ($e->getCode()) {

                case RouterException::ROUTE_NOT_FOUND:
                    $response = new Response();
                    $response = $response->withStatus(404);
                break;
                default:
                    throw $e;

            }
        }

        return $response;
    }
}