<?php

namespace Noa\Example\Middlewares;


use Interop\Http\ServerMiddleware\DelegateInterface;
use Interop\Http\ServerMiddleware\MiddlewareInterface;
use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;

/**
 * Created by PhpStorm.
 * User: Noa
 * Date: 19/09/2017
 * Time: 19:36
 */

class NoaMiddleware implements MiddlewareInterface, PSR7Support
{

    /**
     * Process an incoming server request and return a response, optionally delegating
     * response creation to a handler.
     *
     * @param ServerRequestInterface $request
     * @param DelegateInterface $handler
     *
     * @return ResponseInterface
     */
    public function process(ServerRequestInterface $request, DelegateInterface $handler)
    {
        $response = $handler->process($request);
        $response = $response->withHeader('X-Noa', "Was here");
        return $response;
    }


    public function __invoke(ServerRequestInterface $request, ResponseInterface $response, callable $next)
    {
        $response = $response->withHeader('X-Noa', "Was here");
        return $response;
    }
}